package nuxeoautomationtest;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStream;
import org.nuxeo.ecm.automation.client.Constants;
import org.nuxeo.ecm.automation.client.jaxrs.impl.HttpAutomationClient;
import org.nuxeo.ecm.automation.client.model.Documents;
import org.nuxeo.ecm.automation.client.Session;
import org.nuxeo.ecm.automation.client.model.Document;
import org.nuxeo.ecm.automation.client.model.FileBlob;
import org.nuxeo.ecm.automation.client.model.PropertyMap;

public class NuxeoAutomationTest {

    public static void main(String[] args) throws Exception {
        HttpAutomationClient client
                = new HttpAutomationClient(
                        "http://msv.wara.de:8888/nuxeo/site/automation");
        Session session = client.getSession("Administrator", "baw,dsf!");
        Documents docs = (Documents) session.newRequest("Document.Query").set("query", "SELECT * FROM Document WHERE ecm:tag ILIKE 'nuxeoAuto%'").setHeader(
            Constants.HEADER_NX_SCHEMAS, "*").execute();
//        System.out.println(docs);
        System.out.println(docs.get(0).getTitle());
        System.out.println(docs.get(0).getPath());
//        System.out.println(docs.get(0).getRepository());

        // get the file content property
        System.out.println(docs.get(0).getProperties());
        
        System.out.println(docs.get(0).getId());
        
        FileBlob fb = (FileBlob) session.getFile("http://msv.wara.de:8888/nuxeo/nxbigfile/default/"+docs.get(0).getId());
        
        InputStream is = fb.getStream();

        System.out.println(convertStreamToString(is));
        
        //FileBlob fb = (FileBlob) session.getFile("/default-domain/UserWorkspaces/testus/Anmeldung_Bike_Pool.doc");
         
        
       // PropertyMap map1 = docs.get(0).getProperties().getMap("dc:title");
        //System.out.println(docs.get(0).getProperties().getMap("dc:title"));

        //System.out.println(map1);
     
        //Set keys = map.getKeys();
        
        
//        for(Object o: keys){
//            System.out.println(o.toString());
//        }
        
        // get the data URL
        //String path = map.getString("data");
        
        // download the file from its remote location
        //FileBlob blob = (FileBlob) session.getFile(path);
        
//                // Fetch the root of Nuxeo repository
//                Document root = (Document) session.newRequest("Document.Fetch").set("value", "/").execute();
//                
//                System.out.println(root.getPath());
        //**********************************************************
        
//        // Get The Root
//        Document root = (Document) session.newRequest("Document.Fetch").set("value", "/").execute();
//        // Create a File Document
//        session.newRequest("Document.Create").setInput(root).set("type", "File").set("name", "myfile").set("properties", "dc:title=My File").execute(); 
//        // Upload The file
//        File file = new File("/tmp/fooBlobber.txt");
//        FileBlob fb = new FileBlob(file);
//        fb.setMimeType("text/xml");
//        // uploading a file will return null since we used HEADER_NX_VOIDOP
//        session.newRequest("Blob.Attach").setHeader(Constants.HEADER_NX_VOIDOP, "true").setInput(fb).set("document", "/myfile").execute();  
//        // Get the file document where blob was attached#
//        Document doc = (Document) session.newRequest("Document.Fetch").setHeader(Constants.HEADER_NX_SCHEMAS, "*").set("value", "/myfile").execute();
//        // get the file content property
//        System.out.println(doc.getId());
//        PropertyMap map = doc.getProperties().getMap("file:content");// get the data URL
//        String path = map.getString("data"); 
//        System.out.println(path);
//        // download the file from its remote location
//        //fb = (FileBlob) session.getFile(path);
//        
//        //path zu fuss angepasst: id geandert und den REST geloescht! -> funzt! die datei wird als blob runtergeladen 
//        fb = (FileBlob) session.getFile("http://msv.wara.de:8888/nuxeo/nxbigfile/default/66f1afbf-479b-4eb6-96df-a1cf377927d5");
//        
//
//// ... do something with the file
//        // at the end delete the temporary file
//        
//        InputStream is = fb.getStream();
//     
//        System.out.println(convertStreamToString(is));
//        
//        fb.getFile().delete();
//        
//        
//        client.shutdown();
    }

    static String convertStreamToString(java.io.InputStream is) {
        java.util.Scanner s = new java.util.Scanner(is).useDelimiter("\\A");
        return s.hasNext() ? s.next() : "";
    }
    
}
